aubio 0.4.2~alpha

- Main Page
- Data Structures
- Files
- Examples

- File List
- Globals

pitch.h
Go to the documentation of this file.
1 /*
2 Copyright (C) 2003-2013 Paul Brossier <piem@aubio.org>
3
4 This file is part of aubio.
5
6 aubio is free software: you can redistribute it and/or modify
7 it under the terms of the GNU General Public License as published by
8 the Free Software Foundation, either version 3 of the License, or
9 (at your option) any later version.
10
11 aubio is distributed in the hope that it will be useful,
12 but WITHOUT ANY WARRANTY; without even the implied warranty of
13 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14 GNU General Public License for more details.
15
16 You should have received a copy of the GNU General Public License
17 along with aubio. If not, see <http://www.gnu.org/licenses/>.
18
19 */
20
21 #ifndef _AUBIO_PITCH_H
22 #define _AUBIO_PITCH_H
23
24 #ifdef __cplusplus
25 extern "C" {
26 #endif
27
28 /** \file
29
30 Pitch detection object
31
32 This file creates the objects required for the computation of the selected
33 pitch detection algorithm and output the results, in midi note or Hz.
34
35 \section pitch Pitch detection methods
36
37 A list of the pitch detection methods currently available follows.
38
39 \b \p default : use the default method
40
41 Currently, the default method is set to \p yinfft .
42
43 \b \p schmitt : Schmitt trigger
44
45 This pitch extraction method implements a Schmitt trigger to estimate the
46 period of a signal.
47
48 This file was derived from the tuneit project, written by Mario Lang to
49 detect the fundamental frequency of a sound.
50
51 See http://delysid.org/tuneit.html
52
53 \b \p fcomb : a fast harmonic comb filter
54
55 This pitch extraction method implements a fast harmonic comb filter to
56 determine the fundamental frequency of a harmonic sound.
57
58 This file was derived from the tuneit project, written by Mario Lang to
59 detect the fundamental frequency of a sound.
60
61 See http://delysid.org/tuneit.html
62
63 \b \p mcomb : multiple-comb filter
64
65 This fundamental frequency estimation algorithm implements spectral
66 flattening, multi-comb filtering and peak histogramming.
67
68 This method was designed by Juan P. Bello and described in:
69
70 Juan-Pablo Bello. ``Towards the Automated Analysis of Simple Polyphonic
71 Music''. PhD thesis, Centre for Digital Music, Queen Mary University of
72 London, London, UK, 2003.
73
74 \b \p yin : YIN algorithm
75
76 This algorithm was developed by A. de Cheveigne and H. Kawahara and
77 published in:
78
79 De Cheveigné, A., Kawahara, H. (2002) "YIN, a fundamental frequency
80 estimator for speech and music", J. Acoust. Soc. Am. 111, 1917-1930.
81
82 see http://recherche.ircam.fr/equipes/pcm/pub/people/cheveign.html
83
84 \b \p yinfft : Yinfft algorithm
85
86 This algorithm was derived from the YIN algorithm. In this implementation, a
87 Fourier transform is used to compute a tapered square difference function,
88 which allows spectral weighting. Because the difference function is tapered,
89 the selection of the period is simplified.
90
91 Paul Brossier, [Automatic annotation of musical audio for interactive
92 systems](http://aubio.org/phd/), Chapter 3, Pitch Analysis, PhD thesis,
93 Centre for Digital music, Queen Mary University of London, London, UK, 2006.
94
95 \example pitch/test-pitch.c
96 \example examples/aubiopitch.c
97
98 */
99
100 /** pitch detection object */
101 typedef struct _aubio_pitch_t aubio_pitch_t;
102
103 /** execute pitch detection on an input signal frame
104
105 \param o pitch detection object as returned by new_aubio_pitch()
106 \param in input signal of size [hop_size]
107 \param out output pitch candidates of size [1]
108
109 */
110 void aubio_pitch_do (aubio_pitch_t * o, fvec_t * in, fvec_t * out);
111
112 /** change yin or yinfft tolerance threshold
113
114 \param o pitch detection object as returned by new_aubio_pitch()
115 \param tol tolerance default is 0.15 for yin and 0.85 for yinfft
116
117 */
118 uint_t aubio_pitch_set_tolerance (aubio_pitch_t * o, smpl_t tol);
119
120 /** deletion of the pitch detection object
121
122 \param o pitch detection object as returned by new_aubio_pitch()
123
124 */
125 void del_aubio_pitch (aubio_pitch_t * o);
126
127 /** creation of the pitch detection object
128
129 \param method set pitch detection algorithm
130 \param buf_size size of the input buffer to analyse
131 \param hop_size step size between two consecutive analysis instant
132 \param samplerate sampling rate of the signal
133
134 \return newly created ::aubio_pitch_t
135
136 */
137 aubio_pitch_t *new_aubio_pitch (char_t * method,
138 uint_t buf_size, uint_t hop_size, uint_t samplerate);
139
140 /** set the output unit of the pitch detection object
141
142 \param o pitch detection object as returned by new_aubio_pitch()
143 \param mode set pitch units for output
144
145 \return 0 if successfull, non-zero otherwise
146
147 */
148 uint_t aubio_pitch_set_unit (aubio_pitch_t * o, char_t * mode);
149
150 /** set the silence threshold of the pitch detection object
151
152 \param o pitch detection object as returned by new_aubio_pitch()
153 \param silence level threshold under which pitch should be ignored, in dB
154
155 \return 0 if successfull, non-zero otherwise
156
157 */
158 uint_t aubio_pitch_set_silence (aubio_pitch_t * o, smpl_t silence);
159
160 /** set the silence threshold of the pitch detection object
161
162 \param o pitch detection object as returned by ::new_aubio_pitch()
163
164 \return level threshold under which pitch should be ignored, in dB
165
166 */
167 smpl_t aubio_pitch_get_silence (aubio_pitch_t * o);
168
169 /** get the current confidence
170
171 \param o pitch detection object as returned by new_aubio_pitch()
172
173 \return the current confidence of the pitch algorithm
174
175 */
176 smpl_t aubio_pitch_get_confidence (aubio_pitch_t * o);
177
178 #ifdef __cplusplus
179 }
180 #endif
181
182 #endif /* _AUBIO_PITCH_H */
smpl_t
float smpl_t
short sample format (32 or 64 bits)
Definition: types.h:41
aubio_pitch_set_silence
uint_t aubio_pitch_set_silence(aubio_pitch_t *o, smpl_t silence)
set the silence threshold of the pitch detection object
aubio_pitch_get_silence
smpl_t aubio_pitch_get_silence(aubio_pitch_t *o)
set the silence threshold of the pitch detection object
aubio_pitch_set_tolerance
uint_t aubio_pitch_set_tolerance(aubio_pitch_t *o, smpl_t tol)
change yin or yinfft tolerance threshold
del_aubio_pitch
void del_aubio_pitch(aubio_pitch_t *o)
deletion of the pitch detection object
new_aubio_pitch
aubio_pitch_t * new_aubio_pitch(char_t *method, uint_t buf_size, uint_t hop_size, uint_t samplerate)
creation of the pitch detection object
aubio_pitch_set_unit
uint_t aubio_pitch_set_unit(aubio_pitch_t *o, char_t *mode)
set the output unit of the pitch detection object
aubio_pitch_get_confidence
smpl_t aubio_pitch_get_confidence(aubio_pitch_t *o)
get the current confidence
aubio_pitch_do
void aubio_pitch_do(aubio_pitch_t *o, fvec_t *in, fvec_t *out)
execute pitch detection on an input signal frame
fvec_t
Buffer for real data.
Definition: fvec.h:67
uint_t
unsigned int uint_t
unsigned integer
Definition: types.h:60
char_t
char char_t
character
Definition: types.h:64
aubio_pitch_t
struct _aubio_pitch_t aubio_pitch_t
pitch detection object
Definition: pitch.h:101